#include "buffer.h"
#include "exit.h"

char bspace[256];
buffer b = BUFFER_INIT(buffer_unixwrite,1,bspace,sizeof bspace);

void outs(const char *s)
{
  if (buffer_puts(&b,s) == -1) _exit(111);
}

void outs_octal(const char *s)
{
  unsigned char ch;
  char octal[4];
  while ((ch = *s++)) {
    outs("\\");
    octal[3] = 0;
    octal[2] = '0' + (ch & 7); ch >>= 3;
    octal[1] = '0' + (ch & 7); ch >>= 3;
    octal[0] = '0' + (ch & 7);
    outs(octal);
  }
}

int main(int argc,char **argv)
{
  char *name;
  char *value;
  char **args = argv;
  int c = 2;

  name = *(++args);
  if (!name) _exit(100);
  value = *(++args);
  if (!value) _exit(100);

  outs("char *const ");
  outs(name);
  outs("[] = {\n");

  do {
    outs("\"\\\n");outs_octal(value); outs("\\\n\",\n");
    value = *(++args);
  } while (++c < argc);

  outs("0\n};\n");
  if (buffer_flush(&b) == -1) _exit(111);
  return(0);
}
