#include <unistd.h>
#include <sys/types.h>
#include <stdio.h>
#include "auto_scanq.h"
#include "str.h"
#include "strerr.h"
#include "auto_uids.h"
#include "buffer.h"
#include "auto_pkg.h"
#include "generic-install.h"

const char *FATAL="install-unwrap: fatal: ";

extern const char auto_qmailq_destdir[];
extern const char auto_qmailq_oldpath[];
extern const char auto_qmailbin[];

int main(void)
{
  /* Sanity check */
  if (str_diff(auto_qmailbin,auto_qmailq_destdir) == 0) {
    buffer_puts(buffer_2,FATAL);
    buffer_putsflush(buffer_2,"qmail/bin and qmailq_destdir are the same.\n");
    _exit(111);
  }

  /* Create directories */
  if (chdir(auto_qmailq_destdir) == -1)
    strerr_die4sys(111,FATAL,"unable to chdir to ", auto_qmailq_destdir,": ");
  fn = "qmail-queue";
  if (!file_exists())
    strerr_die4sys(111,FATAL,"no such file: ", auto_qmailq_destdir,"/qmail-queue");
  if (rename("qmail-queue",auto_qmailq_oldpath) == -1)
    strerr_die4sys(111,FATAL,"Unable to rename qmail-queue to ",auto_qmailq_oldpath,": ");
  if (rmdir(auto_qmailq_destdir) == -1)
    strerr_die4sys(111,FATAL,"Unable to delete directory ",auto_qmailq_destdir,": ");
  return(0);
}
