#include <sys/types.h>
#include <unistd.h>
#include "fork.h"
#include "wait.h"
#include "exitcodes.h"

extern char *auto_antivir_cmd[];
int main()
{
  int avstat = -1;
  pid_t pid  = -1;

  /* Launch antivir */
  switch(pid = vfork()) {
    case -1:
	_exit(EX_TMPERR);
    case 0:
	execve(*auto_antivir_cmd, auto_antivir_cmd, 0);
	/* Hopefully not reached. */
	_exit(3); /* this is interpreted as an ANTIVIR xit code */
  }

  /* Catch the exit status */
  if (wait_pid(&avstat, pid) == -1) _exit(EX_TMPERR);
  if (wait_crashed(avstat)) _exit(EX_TMPERR);
  switch(wait_exitcode(avstat)) {
  case(1):
  case(2):
  case(101):
    _exit(EX_VIRUS);
  case(0):
    _exit(EX_ALLOK);
  default:
    _exit(EX_TMPERR);
  }
  /* notreached */
}
